////////////////////////////////////////////////////////////////////////////////
//	Filename :		Error.cpp
//	Description :	Error handling (reporting).
////////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////////////////////////
//	Included headers
////////////////////////////////////////////////////////////////////////////////
#include "Error.h"


////////////////////////////////////////////////////////////////////////////////
//	Global variables
////////////////////////////////////////////////////////////////////////////////
CError			ErrorHandling ("errors.log", true);


////////////////////////////////////////////////////////////////////////////////
//	Functions
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//	Function name :	CError::CError ()
//	Description :	Default constructor for CError class.
////////////////////////////////////////////////////////////////////////////////
CError::CError (LPSTR lpzFileName, bool bQuitOnError)

{

	
	fErrorLog = fopen (lpzFileName, "wt");	// opens the file for writing in text 
											// mode
	bQuit = bQuitOnError;					// sets the quit flag

}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	CError::~CError ()
//	Description :	Default destructor for CError class.
////////////////////////////////////////////////////////////////////////////////
CError::~CError ()

{


}


////////////////////////////////////////////////////////////////////////////////
//	Function name :	CError::ProcessError ()
//	Description :	Processes the actual error.
////////////////////////////////////////////////////////////////////////////////
CError::ProcessError (DWORD	dwError)

{

DWORD	dwMsgSize;

	switch (dwError)	

	{

		case ERROR_REGISTER_CLASS :
	
			dwMsgSize = strlen ("Chapter 2 - Error log file\nCould'nt register class...\n");
														// set message lenght
			lpzMessage = (LPSTR) malloc (dwMsgSize + 1);// allocate memory for 
														// message using 
														// message 
														// length plus one for 
														// '\0' character
			strcpy (lpzMessage, "Chapter 2 - Error log file\nCould'nt register class...\n");	
														// copies the message 
														// to the string
			break;

		default :
	
			dwMsgSize = strlen ("Chapter 2 - Error log file\nUnkown error...\n");
														// set message lenght
			lpzMessage = (LPSTR) malloc (dwMsgSize + 1);// allocate memory for 
														// message using 
														// message 
														// length plus one for 
														// '\0' character
			strcpy (lpzMessage, "Chapter 2 - Error log file\nUnkown error...\n");	
														// copies the message 
														// to the string
			break;

	}

	if (fErrorLog != NULL) 					// if file is open

	{

		fprintf (fErrorLog, lpzMessage);	// write message to file

	}

	if (lpzMessage != NULL)				// if string exists

	{

		free (lpzMessage);				// free string memory

	}

	if (bQuit == true)					// if quit on error

	{

		if (fErrorLog  != NULL)					// if file is open


		{

			fclose (fErrorLog);						// close file

		}
		
		PostQuitMessage (dwError);		// quit supplying error

	}

	free (lpzMessage);

	return 0;

}

